package at.ac.tuwien.dbai.ges.instances;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

/**
 * Allows to generate a whole batch of instances based on an instruction file.
 *
 * @author Lucas Kletzander
 */
public class AutoGenerator {

    public static void main(String[] args) {

        if (args.length != 3) {
            System.out.println("Arguments: <config-path> <instruction-file> <output-path>");
            return;
        }

        try {

            Scanner scanner = new Scanner(new File(args[0] + File.separator + args[1]));
            int startSeed = Integer.parseInt(scanner.nextLine());

            while (scanner.hasNextLine()) {

                int seed = startSeed;

                String[] parts = scanner.nextLine().split(" ");
                int iterations = Integer.parseInt(parts[1]);

                for (int i = 0; i < iterations; i++) {

                    System.out.println("Processing " + parts[0] + " instance " + i);

                    GesInstanceGenerator.main(new String[] {args[0] + File.separator + parts[0],
                            args[2] + File.separator + "instances" + File.separator + "instance_" + parts[0] + "_" + seed + ".xml",
                            args[2] + File.separator + "solutions" + File.separator + "solution_" + parts[0] + "_" + seed + ".xml",
                            String.valueOf(seed)});

                    seed++;

                }

            }

        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }

    }

}
