package at.ac.tuwien.dbai.ges.instances;

import at.ac.tuwien.dbai.ges.instances.transformer.ScheduleTransformer;

/**
 * Generates an instance based on the config file.
 *
 * @author Lucas Kletzander
 */
public class GesInstanceGenerator {

    public static void main(String[] args) {

        if (args.length < 3 || args.length > 4) {
            System.out.println("Arguments: <config_file> <problem_file> <solution_file> [<random_seed>]");
            return;
        }

        if (args.length == 4) {
            RandomProvider.initialize(Integer.parseInt(args[3]));
        } else {
            RandomProvider.initialize();
        }

        ScheduleConfig config = ScheduleConfig.load(args[0]);

        ScheduleGenerator generator = new ScheduleGenerator(config);
        generator.createShifts();
        generator.createBreaks();
        generator.createTasks();

        ScheduleTransformer transformer = new ScheduleTransformer(generator);
        transformer.transform(args[1], args[2]);

    }

}
