package at.ac.tuwien.dbai.ges.instances.breaks;

/**
 * Defines a break type.
 *
 * @author Lucas Kletzander
 */
public class BreakType {

    private int minLength;
    private int maxLength;
    private int minStartShift;
    private int maxEndShift;
    private int maxStartShift;
    private int startShiftWeight;
    private int minWorkBefore;
    private int maxWorkBefore;

    public int getMinLength() {
        return minLength;
    }

    public void setMinLength(int minLength) {
        this.minLength = minLength;
    }

    public int getMaxLength() {
        return maxLength;
    }

    public void setMaxLength(int maxLength) {
        this.maxLength = maxLength;
    }

    public int getMinStartShift() {
        return minStartShift;
    }

    public void setMinStartShift(int minStartShift) {
        this.minStartShift = minStartShift;
    }

    public int getMaxEndShift() {
        return maxEndShift;
    }

    public void setMaxEndShift(int maxEndShift) {
        this.maxEndShift = maxEndShift;
    }

    public int getMaxStartShift() {
        return maxStartShift;
    }

    public void setMaxStartShift(int maxStartShift) {
        this.maxStartShift = maxStartShift;
    }

    public int getStartShiftWeight() {
        return startShiftWeight;
    }

    public void setStartShiftWeight(int startShiftWeight) {
        this.startShiftWeight = startShiftWeight;
    }

    public int getMinWorkBefore() {
        return minWorkBefore;
    }

    public void setMinWorkBefore(int minWorkBefore) {
        this.minWorkBefore = minWorkBefore;
    }

    public int getMaxWorkBefore() {
        return maxWorkBefore;
    }

    public void setMaxWorkBefore(int maxWorkBefore) {
        this.maxWorkBefore = maxWorkBefore;
    }

    public int getEarliestBreakBefore() {
        return minStartShift - maxWorkBefore;
    }

    public int getLastestBreakBefore(int shiftLength) {
        return Math.min(startShiftWeight == 0 ? Integer.MAX_VALUE : maxStartShift - minWorkBefore, shiftLength - maxEndShift - minLength - minWorkBefore);
    }

    @Override
    public String toString() {
        return "BreakType{" +
                "minLength=" + minLength +
                ", maxLength=" + maxLength +
                ", minStartShift=" + minStartShift +
                ", maxEndShift=" + maxEndShift +
                ", maxStartShift=" + maxStartShift +
                ", startShiftWeight=" + startShiftWeight +
                ", minWorkBefore=" + minWorkBefore +
                ", maxWorkBefore=" + maxWorkBefore +
                '}';
    }

}
