package at.ac.tuwien.dbai.ges.instances.employee;

import at.ac.tuwien.dbai.ges.schema.EmployeeList;

import java.util.ArrayList;
import java.util.List;

/**
 * Monitors and applies a configuration for an employee.
 *
 * @author Lucas Kletzander
 */
public class EmployeeMonitor {

    List<EmployeeConfiguration> preferences = new ArrayList<>();

    public void addConfiguration(EmployeeConfiguration preference) {
        preferences.add(preference);
    }

    public void applyConfigurations(EmployeeList.Employee employee, EmployeeSchedule schedule) {

        for (EmployeeConfiguration preference : preferences) {
            preference.transformForRow(employee, schedule);
        }

    }

}
