package at.ac.tuwien.dbai.ges.instances.employee;

import at.ac.tuwien.dbai.ges.instances.shift.ShiftDetails;

import java.util.List;

/**
 * Models the shift schedule for a specific employee.
 *
 * @author Lucas Kletzander
 */
public class EmployeeSchedule {

    private final int id;
    private final int contract;
    private List<Integer> skills;
    private List<ShiftDetails> details;

    public EmployeeSchedule(int id, int contract) {
        this.id = id;
        this.contract = contract;
    }

    public int getId() {
        return id;
    }

    public int getContract() {
        return contract;
    }

    public List<Integer> getSkills() {
        return skills;
    }

    public void setSkills(List<Integer> skills) {
        this.skills = skills;
    }

    public List<ShiftDetails> getDetails() {
        return details;
    }

    public void setDetails(List<ShiftDetails> details) {
        this.details = details;
    }

}
