package at.ac.tuwien.dbai.ges.instances.shift;

/**
 * Specifies a shift instance.
 *
 * @author Lucas Kletzander
 */
public class ShiftInstance {

    private final int shiftType;
    private final int startTime;
    private final int duration;

    public ShiftInstance(int shiftType, int startTime, int duration) {

        this.shiftType = shiftType;
        this.startTime = startTime;
        this.duration = duration;

    }

    public int getShiftType() {
        return shiftType;
    }

    public int getStartTimeNative() {
        return startTime;
    }

    public int getStartTime() {
        return startTime % (24 * 60);
    }

    public int getEndTimeNative() {
        return startTime + duration;
    }

    public int getEndTime() {
        return (startTime + duration) % (24 * 60);
    }

    public int getDuration() {
        return duration;
    }

    @Override
    public String toString() {
        return "ShiftInstance{" +
                "shiftType=" + shiftType +
                ", startTime=" + (getStartTime() / 60) + ":" + (getStartTime() % 60) +
                ", duration=" + (duration / 60) + ":" + (duration % 60) +
                '}';
    }

}
