package at.ac.tuwien.dbai.ges.instances.transformer;

import at.ac.tuwien.dbai.ges.instances.ScheduleGenerator;

/**
 * Transforms the problem and solution to the corresponding XML formats.
 *
 * @author Lucas Kletzander
 */
public class ScheduleTransformer {

    private final ScheduleGenerator generator;

    public ScheduleTransformer(ScheduleGenerator generator) {
        this.generator = generator;
    }

    public void transform(String problemFile, String solutionFile) {

        System.out.println("Writing problem file...");
        HorizonTransformer transformer = new HorizonTransformer(generator);
        transformer.transform();
        transformer.printToFile(problemFile);

        System.out.println("Writing solution file...");
        SolutionTransformer solutionTransformer = new SolutionTransformer(generator, problemFile);
        solutionTransformer.transform();
        solutionTransformer.printToFile(solutionFile);

    }

}
